
line: ; r3=x, r4=y, r5=x2, r6=y2
	mov a,r5
	cpl a
	inc a
	add a,r3
	jnc	line_skip1
	mov a,r3	; swap so always drawing left to right
	xch a,r5
	mov r3,a	
	mov a,r4
	xch a,r6
	mov r4,a
line_skip1:
	mov a,r5	; work out w (always +ve)
	cpl a
	add a,r3	;r5 - r3
	cpl a
	mov r5,a

	mov a,r6	; work out h
	cpl a
	add a,r4
	;mov r7,-1 					;cpl a
	mov r6,a                    ;mov r6,a
	inc	r6                      ;rlc a		; test negative bit
	cpl	a	                    ;jnc line100
	mov	r7,a	;-1/+1 flag
	jb7 line100	;negative ok    ;
	mov	r6,a	                ;mov a,r6
	;mov	r7,1                    ;cpl a
	                            ;inc a		; negate
	                            ;mov r6,a
	                            ;mov r7,256-1
line100:
	mov a,r5	; which axis is the longest?
	cpl a
	add a,r6
	jc line101

	mov a,r5
	mov r1,a
	rrc a		;(carry clear from above)	;rrc a	
	                                        ;anl a,$7f
	mov r2,a
	;jmp	line_x	;call line_x
				;ret
				
	; draw a line, x stepping, y direction is set by sy
	; r3=x, r4=y, r5=w, r6=h, r7=sy, r2=n
line_x:
	;mov a,r5	;w
	;mov r1,a	
line_x_loop:
	call plot
	mov a,r2		 
	add a,r6		;r2+=r6	n+=h
	mov r2,a
	mov a,r5		
	cpl a			;-r5 -w
	inc a
	add a,r2		; carry clear if n>=w
	jnc line_x_skip
	mov r2,a		; n-=w;
	mov a,r4		
	add a,r7		;r7+r4	y+sy
	mov r4,a
line_x_skip:
	inc r3			;r3+1	x+1
	djnz r1,line_x_loop
	ret
				
line101:
	mov a,r6
mov r1,a
	cpl c		;(clears carry from above)	;rr a
	rrc a									;anl a,$7f
	mov r2,a
	;jmp	line_y	;call line_y
				;ret
				
	; draw a line, x stepping, y direction is set by sy
	; r3=x, r4=y, r5=w, r6=h, r7=sy, r2=n
line_y:
	;mov a,r6
	;mov r1,a
line_y_loop:
	call plot
	mov a,r2		; n+=h
	add a,r5
	mov r2,a
	mov a,r6		; h
	cpl a			; 2s comp
	inc a
	add a,r2		; carry clear if n>=w
	jnc line_y_skip
	mov r2,a		; n-=h;
	inc r3			;x+1
line_y_skip:
	mov a,r4		; y+sy;
	add a,r7
	mov r4,a
	djnz r1,line_y_loop
	ret
	