; fake mesh drawing dndn1011

;ramp_lines:  ; end with 0
;	.db 4		,8		,8		,12		,12		,16		,16		,4
;	.db 4	    ,8	|128,8	|128,12|128	,12|128, 16
;	.db 8,8|128,12,12|128
;	.db 0

cube_lines:
	;.db 4		,8		,8		,12		,12		,16		,16		,4
	;.db 4	|128,8	|128,8	|128,12|128	,12	|128,16	|128,16	|128,4	|128
	;.db 4		,4	|128,8		,8	|128,12		,12	|128,16		,16	|128
	;.db 0 ;end marker
	
	.db (2	<<4)+4		,(4	 <<4)+6 	,(6	 <<4)+8		,(8  <<4)+2
	.db (2+1<<4)+4+1	,(4+1<<4)+6+1	,(6+1<<4)+8+1	,(8+1<<4)+2+1
	.db (2	<<4)+2+1	,(4	 <<4)+4+1	,(6	 <<4)+6+1	,(8	 <<4)+8+1
	.db 0 ;end marker

pyramid_lines:
	;.db 4		,8		,8		,12		,12		,16		,16		,4
	;.db 4		,20		,8		,20		,12		,20		,16		,20
	;.db 0 ;end marker
	
	.db (2 <<4)+ 4		,(4 <<4)+6		,(6 <<4)+8		,(8 <<4)+2
	.db (2 <<4)+ 14		,(4 <<4)+14		,(6 <<4)+14		,(8 <<4)+14
	.db 0 ;end marker

	; 8			6
	;			a
	; 2			4
ship_lines:	
	.db $2a,$a8,$ad,$2d,$8d,$24,$68,$28,0

	; a = mesh address (must be in this bank)
draw_mesh:
	mov r0,mesh_select
	mov @r0,a
dc1:
	anl p1,XVRAM1
	mov r0,mesh_select
	
	mov	a,-(ship_lines & $FF)
	add a,@r0			;test if dealing with ship
	mov	r7,10			;ship height
	jc	$+4
	mov	r7,18			;other height
	
	call dcsub2
	jz dcsub_ret		;end of table
dc2:
	movx a,@r1
	mov r3,a
	call dcsub1
	mov r4,a
	call dcsub3
	movx a,@r1
	mov r5,a
	call dcsub1
	mov r6,a
	orl	p1,XVRAM3
	call line	
	jmp dc1
	
dcsub1:	
	inc r1	
	inc r1	
	movx a,@r1
	rr a
	anl	a,$7F
	jnc dc4
	add a,r7 			;18	
dc4:
	add a,2
dcsub_ret:
	ret
dcsub2:	
	mov	a,@r0
	movp a,@a
	swap a	
dc5:	
	anl	a,$0F
	clr	c		
	rrc a		;bit 0 to carry, 0 to bit 7
	rl	a
	rl	a		;indices are multiples of 4
	mov r1,a
	ret
	
dcsub3:	
	mov	a,@r0
	inc	@r0
	movp a,@a
	jmp	dc5
	
.equ centre_x,25
.equ centre_y,20
.equ cube_sx,12
.equ cube_sy,12

mesh_verts:
	.db centre_x | $80,centre_y						; 0
	.db centre_x - cube_sx,centre_y - cube_sy		; 2
	.db centre_x + cube_sx,centre_y - cube_sy		; 4
	.db centre_x + cube_sx,centre_y + cube_sy		; 6
	.db centre_x - cube_sx,centre_y + cube_sy		; 8
	.db centre_x + cube_sx,centre_y					; a
	.db centre_x - cube_sx,centre_y					; c
	.db centre_x,centre_y + 40						; e
	.db 0
	
set_mesh_verts:
	mov a,XVRAM1
	outl p1,a
	; first point is centre of spin
	mov r1,0
	mov r0,mesh_verts & $ff
cubeloop:
	mov a,r0
	movp a,@a
	jz dcsub_ret	;end of table
	
	movx @r1,a
	inc r1
	clr a
	movx @r1,a
	inc r1
	inc r0
	jmp cubeloop 
;cubeloopend:
;	ret
