
; transform points (originally starfield)
; dndn1011


; In Bank 3
; First 4 bytes are coords of centre of effect
; Rest are verts, 4 bytes each
;  a = number of verts to transform
; r1 = first vert
; transform_spin = type of transform
;		b0 = x spin +
;		b1 = x spin -
;		b2 = y spin +
;		b3 = y spin -
;		b4 = x zoom off
;		b5 = y zoon off
transform:
	;mov	a,r7		;verts
	mov r0,transform_temp
transform_loop:
	mov @r0,a
	
	mov	r0,REG_RB1R3
	mov	r7,4
movestar_getl:	
	movx a,@r1
	inc	r1
	mov @r0,a
	inc	r0
	djnz r7,movestar_getl	
	
	;movx  a,@r1		
	;mov	  r3,a 		;r3
	;inc   r1   
	;movx  a,@r1
	;mov	  r4,a		;r4
	;inc   r1
	;movx  a,@r1
	;mov	  r5,a		;r5
	;inc   r1
	;movx  a,@r1
	;mov	  r6,a		;r6
	;inc   r1

	mov a,r3
	anl	a,$C0		  ;jb7	 movestar_skip  ; top bit set, then don't process (not active)
	jnz	movestar_skip ;jb6	 movestar_skip  ; 6th bit set, then don't process (not a star)	

	; ------------X--------------
	; subtract centre
	mov r0,a	;a=0	; X centre
	movx a,@r0
	anl a,$3f
	cpl	a	
	inc	a   
	add	a,r3
ms3:
	; divide by 16 and sign extend into r1 and r2
	swap a
	mov r7,a	; msb
	anl a,$f0
	mov r2,a	; lsb

	mov a,r4	; preserve information in lsb
	swap a
	anl a,$f
	orl a,r2
	mov r2,a

	mov a,r7	
	orl	a,$F0
	jb3 ms4		; sign extend
ms41:
	xrl a,$f0
ms4:
	mov	r7,a
	
	; spin
	; y += x*k

	mov r0,transform_spin  ; direction of spin
	mov a,@r0
	jb0 ms200
	jb1 ms201
	jmp ms202
ms200:
	mov a,r6
	add a,r2
	mov r6,a
	mov a,r5
	addc a,r7	
	mov r5,a
	jmp ms202
ms201:
	mov a,r6	;r5.r6-r0.r2
	cpl a
	add a,r2
	cpl a
	mov r6,a
	mov a,r5
	cpl a
	addc a,r7	
	cpl a
	mov r5,a
	
ms202:
	;mov r0,transform_spin
	mov a,@r0
	jb4 ms203				; skip forward movement

	; forward movement
	; x2
	mov a,r2				;r0.r2<< 1
	add a,r2
	mov r2,a
	mov a,r7
	rlc a
	mov r7,a

	; 16 bit add to x
	mov a,r4				;r3.r4 + r0.r2
	add a,r2
	mov r4,a
	mov a,r3
	addc a,r7
	mov r3,a
	
ms203:
	; ------------Y--------------
	; subtract centre
	mov r0,2	; Y centre
	movx a,@r0
	anl a,$3f
	mov r7,a	

	mov a,r5	;r5 - r7
	cpl	a
	add a,r7
	cpl a

	; divide by 16 and sign extend into r1 and r2
	swap a
	mov r7,a	; msb
	anl a,$f0
	mov r2,a	; lsb

	mov a,r6	; preserve information in lsb
	swap a
	anl a,$f
	orl a,r2
	mov r2,a

	mov a,r7
	;anl a,$0f
	orl	a,$F0
	jb3 ms5 ;1		; sign extend
	;jmp ms5
ms51:
	xrl a,$f0
ms5:
	mov	r7,a
	
	mov r0,transform_spin  ; direction of spin
	mov a,@r0
	jb2 ms300
	jb3 ms301
	jmp ms302

ms300:
	; spin
	; x -= y*k
	mov a,r4
	add a,r2
	mov r4,a
	mov a,r3
	addc a,r7
	mov r3,a
	jmp ms302
ms301:
	; spin
	; x -= y*k
	mov a,r4
	cpl a
	add a,r2
	cpl a
	mov r4,a
	mov a,r3
	cpl a
	addc a,r7
	cpl a
	mov r3,a
ms302:
	;mov r0,transform_spin
	mov a,@r0
	jb5 ms303			; skip forward movement

	; x2
	mov a,r2				;r0.r2<< 1
	add a,r2
	mov r2,a
	mov a,r7
	rlc a
	mov r7,a
	
	; 16 bit add to x
	mov a,r6
	add a,r2
	mov r6,a
	mov a,r5
	addc a,r7
	mov r5,a

ms303:
	; check if out of screen
	
	mov a,r3
	add a,256-50
	jc movestar_clip
	mov a,r5
	add a,256-40
	jnc movestar_set

movestar_clip:

	dec r1
	dec r1
	dec r1
	dec r1
	call reset_star

movestar_next:

	inc r1
	inc r1
	inc r1
	inc r1

movestar_skip:
	mov r0,transform_temp
	mov	a,@r0
	dec a
	jnz transform_loop
	ret
	
movestar_set:

	mov	r0,REG_RB1R6
	mov	r7,4
movestar_setl:	
	mov	a,@r0
	dec	r0
	dec	r1
	movx @r1,a
	djnz r7,movestar_setl	
		
	;dec   r1		
	;mov	  a,r6			
	;movx  @r1,a		
	;dec   r1		
	;mov	  a,r5				
	;movx  @r1,a				
	;dec   r1				
	;mov	  a,r4				
	;movx  @r1,a				
	;dec   r1
    ;mov	  a,r3
    ;movx  @r1,a
	
	jmp movestar_next
