;------------------------------
;initialize scrolly to to begin
;------------------------------

.equ	SM_SINEON,	$40
.equ	SM_SINEOFF,	$00
.equ	SM_MOVEON,	$00
.equ	SM_MOVEOFF,	$80

.equ	SM_MAXYPOS,	26
.equ	SM_MINYPOS,	7

;	a=text
;	r1=Move,Sine,start position 

initscrolly:
	mov	r0,IRAM_PTEXT	;clear text position
	mov	@r0,a
		
	mov	r0,IRAM_CHCNT	;clear character row counter
	mov	@r0,$07			;signal fetch char immediately
	mov r0,IRAM_SCROW	;display start row offset
	mov @r0,$F5			;last righthand offset
	inc r0				;IRAM_WTPOS
	
	mov a,r1
	mov @r0,wavetable & $FF	;sine on
	jb6 $+4
	mov @r0,0				;sine off
	mov	r0,IRAM_SCPOS
	anl	a,$BF			;move up by default
	mov	@r0,a			;scrolly Y pos
	ret
	
;----------------------------------------------------
;SHOW the scrolly part 2
;----------------------------------------------------
	
showscrolly:

;Entry:
;	A = Y start position

;Used:
;	A, flags

;Unchanged:
;	RB0-RB7 of RB 1

	sel rb0
	mov r0,IRAM_SCPOS
	mov a,@r0				;Get scrolly Y pos 
	anl a,$7				;keep byte pixel pos
	mov r3,a				;y shift
	jmp showscrolly_part2
	
;----------------------------------------------------