;Adventure Vision boobiegirl include v1.07 by MrBlinky March 2013
;===============================================================================

.equ	BG_FRAMES, -64*FPS - 11 -22 ;(end sound fix)
.equ	BG_SCROLL_FRAMES,-BG_FRAMES-50 ;3*FPS

.ifndef	MEGABIOS_ASM		;no bios included asume standalone test
.set	BG_CODE_TEST, 1
	.include "includes\megabios.asm"
start:				
.endif

;-- initialize --

bg_init:
	mov	r1,IRAM_DSPMODE
	mov	@r1,DM_GREY
    mov	a,SC_MSG07 & $FF
	mov	r1,SM_MOVEON+SM_SINEON+7
	call initscrolly	
	
	mov	a,BG_FRAMES & $FF
	mov r1,BG_FRAMES >> 8
	call AV_SETTRIGGER2
	
;-- main loop --
	
	orl	p1,XVRAM3
bg_main:
	mov r7,bg_imgtab & $FF	;frame pointer
bg_frame:	
	mov r0,REG_RB0R0		;copy regs to register bank 0 regs
	mov r1,5
bg_ldregs:
	mov a,r7
	inc r7
	movp a,@a
	mov @r0,a
	inc r0
	djnz r1,bg_ldregs
	in a,p1
	xrl a,$01				;toggle dim/bright displays
	outl p1,a		
	call cls				;clear display
	sel rb0
	call unpack_bnp			;unpack half of symetric image
	sel rb1
	
	;mirror rows 0-23 to rows 25-48, row 49 untouched

	mov r0,$06				;display row 0 bottom column
	mov r1,$F6				;display row 48 bottom column
	mov r3,24
bg_row:	
	mov r2,5
bg_col:	
	movx a,@r0
	movx @r1,a
	inc r0
	inc r1
	djnz r2,bg_col
	mov a,r1
	add a,256-10					
	mov r1,a
	djnz r3,bg_row
	
	;do bright display part
	
	in a,p1		
	cpl a					;b0=1 after dim display done
	jb0 bg_frame			;dim display done, do bright
	
	mov r2,BG_SCROLL_FRAMES & $FF
	mov r1,BG_SCROLL_FRAMES >> 8
	call AV_TESTTRIGGER2
	jnc bg_noscrolly
	
	call showscrolly
bg_noscrolly:
	call AV_SHOW_WITHSCROLL
	jnc	bg_break			;break demo part

	mov	r1,M_PLAY_CTR		;demo heartbeat changes each frame
	mov	a,@r1
	jb0	bg_nextframe

	mov	a,r7		
	add	a,-10		;point back to previous frame for every even frame
	mov	r7,a
	
bg_nextframe:	
	mov	a,r7
	add	a,<(256-<bg_imgtabe)	;last frame
	jnz	bg_frame
	jmp	bg_main
	
bg_break:

;boobiegirl image table
;---------------------------------------

bg_imgtab:	
	.db	6+BG1D_START, BGDBANK , BG1D_DATA & $FF, BG1D_PACKETS, BG1D_FLAG ;frame 1
	.db	6+BG1B_START, BGBBANK , BG1B_DATA & $FF, BG1B_PACKETS, BG1B_FLAG
	
	.db	6+BG2D_START, BGDBANK , BG2D_DATA & $FF, BG2D_PACKETS, BG2D_FLAG ;frame 2
	.db	6+BG2B_START, BGBBANK , BG2B_DATA & $FF, BG2B_PACKETS, BG2B_FLAG

	.db	6+BG3D_START, BGDBANK , BG3D_DATA & $FF, BG3D_PACKETS, BG3D_FLAG ;frame 3
	.db	6+BG3B_START, BGBBANK , BG3B_DATA & $FF, BG3B_PACKETS, BG3B_FLAG
	
	.db	6+BG2D_START, BGDBANK , BG2D_DATA & $FF, BG2D_PACKETS, BG2D_FLAG ;frame 2
	.db	6+BG2B_START, BGBBANK , BG2B_DATA & $FF, BG2B_PACKETS, BG2B_FLAG
bg_imgtabe:	

;boobiegirl end
;===============================================================================
