;===============================================================================
;
;	>> Checkers - Zoom - Part 1<< by JAC!, 2013-03-20/22
;	No page alignment required, any VRAM bank will do
;
;===============================================================================

.equ	start_x, IRAM_20	;Word
.equ	mask, 63			;Byte, const

.equ	CHECKERS_FRAMES, -23*FPS	

checkers_zoom2:
	;call checkers_zoom
	;clr f1
	cpl f1
	mov a,SC_MSG05 & $FF
	mov	r1,SM_MOVEON+SM_SINEON+20
	;jmp checkers_zoom
	
	checkers_zoom1:
	
checkers_zoom:
	call initscrolly
	mov	a,CHECKERS_FRAMES & $FF
	mov	r1,CHECKERS_FRAMES >> 8
	call AV_SETTRIGGER2		;(SETTRIGGER1 for less then 255 frames)

checkers_loop:
	mov r1,IRAM_FRAMES		;Animate
	mov a,@r1
	jb6 checkers_greater_mask
	.db	$BE					;'mov r6,n' to do jmp $+1
checkers_greater_mask:
	cpl a
	anl a,mask

	mov r1,a				;Start value

	mov r0,start_x
	add a,@r0
	mov @r0,a
	mov r3,a				;X low

	inc r0	
	clr a
	addc a,@r0
	mov @r0,a
	mov r5,a				;X high

	;mov r7,50				;50 columns
	mov r0,6				;Screen memory start offset in page
checkers_loopx:

	call checkers_set_pixels

	mov a,r3
	add a,r1
	mov r3,a
	jnc checkers_no_inc_x
	inc r5
checkers_no_inc_x:

	jf1 checkers_no_inc_r1
	inc r1
checkers_no_inc_r1:
	mov	a,r0				;Run to $100 instead of $fa
	jnz checkers_loopx
	call showscrolly
	call AV_SHOW_WITHSCROLL
	jc	checkers_loop
	jmp AV_CLS

checkers_show_end: