	; Adventure Vision Demo
	; * Mega Logo Zoomer 
	; by sy2002, Mar 23 2013
	
	; MEGA-ZOOMER: Sequence code that is implementing Scene #6

mz_scene_06_sequencer:
	sel mb0

	; ----------------------------------------------------
	; sequence 1:	stars continue to fly straight
	;				zoomer moves linear
	; ----------------------------------------------------
	
	; check duration of sequence 1
	mov	r2, mz_sc6_duration_seq1 & $FF
	mov r1, mz_sc6_duration_seq1 >> 8
	call AV_TESTTRIGGER2
	
	; set parameters for sequence 1
	clr a							; linear stars (STARS_LINEAR == 0)
	mov r0, MZ_ALLOW_XY	
	mov @r0, %10000000				; y-only movement
	
	jnc mz_jmptbl_show_stars

	; ----------------------------------------------------
	; sequence 2:	stars start rotating to the right
	;				zoomer continues to move linear
	; ----------------------------------------------------

	; check duration of sequence 2
	mov	r2, mz_sc6_duration_seq2 & $FF
	mov r1, mz_sc6_duration_seq2 >> 8
	call AV_TESTTRIGGER2
	
	; set parameters for sequence 2
	mov a, STARS_ROTATE_RIGHT		; start to rotate right
	
	jnc mz_jmptbl_show_stars
	
	; ----------------------------------------------------
	; sequence 3:	stars continue to rotate
	;				zoomer starts to move circular
	; ----------------------------------------------------

	; check duration of sequence 3
	mov	r2, mz_sc6_duration_seq3 & $FF
	mov r1, mz_sc6_duration_seq3 >> 8
	call AV_TESTTRIGGER2
	
	; set parameters for sequence 3
	mov r0, MZ_ALLOW_XY
	mov @r0, %00000000				; logo does circular xy-movement
	mov a, STARS_ROTATE_RIGHT		; stars continue rotating right
	
	jnc mz_jmptbl_show_stars
	
	; ----------------------------------------------------
	; sequence 4:	stars start rotating to the left
	;				zoomer continues circular
	; ----------------------------------------------------

	mov r0, MZ_SHOW_CR
	sel mb1
	jmp mz_scene_6_seq4
	
mz_jmptbl_show_stars:
	sel mb1
	jmp dl_show_stars

