; point plotting routine dndn1011

bit_lookup:
	.db $FE,$FD,$FB,$F7,$EF,$DF,$BF,$7F ;and bitmask table
	; xor plot
	; r3 = x
	; r4 = y
	; all safe except a and r0

plot:
	mov a,r4	;Y/8
	rl a
	swap a
	anl a,$07
	add	a,6	;*first visible display addr
	add	a,r3	;(Y/8) + 5*x
	add	a,r3
	add	a,r3
	add	a,r3
	add	a,r3	
	mov	r0,a

	;;slow bit (saves 2 bytes and no page align)
	;mov a,r4
	;anl	a,$07
	;inc	a
	;xch	a,r7	;r7=save bit mask,a=-1/1 flag
	;rlc	a		;save in carry
	;mov	a,$7F
	;rl	a
	;djnz r7,$-1
	;mov	r7,a
	
	; bit
	mov a,r4
	anl a,$07
	movp a,@a
	xch a,r7	;r7=save bit mask,a=-1/1 flag
	rlc a		;save in carry

	;set pixel
	movx	a,@r0
	anl	a,r7
	movx	@r0,a
	mov	r7,1	;make r7 -1/1  accordinly to flag state
	jnc $+4
	mov	r7,-1
plot_crop:
	ret
	